const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class SubscriptionsDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const subscriptions = await db.subscriptions.create(
      {
        id: data.id || undefined,

        status: data.status || null,
        current_period_start: data.current_period_start || null,
        current_period_end: data.current_period_end || null,
        payment_provider: data.payment_provider || null,
        provider_customer_id: data.provider_customer_id || null,
        provider_subscription_id: data.provider_subscription_id || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await subscriptions.setTenant(data.tenant || null, {
      transaction,
    });

    await subscriptions.setPlan(data.plan || null, {
      transaction,
    });

    await subscriptions.setAgences(data.agences || null, {
      transaction,
    });

    return subscriptions;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const subscriptionsData = data.map((item, index) => ({
      id: item.id || undefined,

      status: item.status || null,
      current_period_start: item.current_period_start || null,
      current_period_end: item.current_period_end || null,
      payment_provider: item.payment_provider || null,
      provider_customer_id: item.provider_customer_id || null,
      provider_subscription_id: item.provider_subscription_id || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const subscriptions = await db.subscriptions.bulkCreate(subscriptionsData, {
      transaction,
    });

    // For each item created, replace relation files

    return subscriptions;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const subscriptions = await db.subscriptions.findByPk(
      id,
      {},
      { transaction },
    );

    const updatePayload = {};

    if (data.status !== undefined) updatePayload.status = data.status;

    if (data.current_period_start !== undefined)
      updatePayload.current_period_start = data.current_period_start;

    if (data.current_period_end !== undefined)
      updatePayload.current_period_end = data.current_period_end;

    if (data.payment_provider !== undefined)
      updatePayload.payment_provider = data.payment_provider;

    if (data.provider_customer_id !== undefined)
      updatePayload.provider_customer_id = data.provider_customer_id;

    if (data.provider_subscription_id !== undefined)
      updatePayload.provider_subscription_id = data.provider_subscription_id;

    updatePayload.updatedById = currentUser.id;

    await subscriptions.update(updatePayload, { transaction });

    if (data.tenant !== undefined) {
      await subscriptions.setTenant(
        data.tenant,

        { transaction },
      );
    }

    if (data.plan !== undefined) {
      await subscriptions.setPlan(
        data.plan,

        { transaction },
      );
    }

    if (data.agences !== undefined) {
      await subscriptions.setAgences(
        data.agences,

        { transaction },
      );
    }

    return subscriptions;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const subscriptions = await db.subscriptions.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of subscriptions) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of subscriptions) {
        await record.destroy({ transaction });
      }
    });

    return subscriptions;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const subscriptions = await db.subscriptions.findByPk(id, options);

    await subscriptions.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await subscriptions.destroy({
      transaction,
    });

    return subscriptions;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const subscriptions = await db.subscriptions.findOne(
      { where },
      { transaction },
    );

    if (!subscriptions) {
      return subscriptions;
    }

    const output = subscriptions.get({ plain: true });

    output.invoices_saas_subscription =
      await subscriptions.getInvoices_saas_subscription({
        transaction,
      });

    output.tenant = await subscriptions.getTenant({
      transaction,
    });

    output.plan = await subscriptions.getPlan({
      transaction,
    });

    output.agences = await subscriptions.getAgences({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userAgences = (user && user.agences?.id) || null;

    if (userAgences) {
      if (options?.currentUser?.agencesId) {
        where.agencesId = options.currentUser.agencesId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.tenants,
        as: 'tenant',

        where: filter.tenant
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.tenant
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  name: {
                    [Op.or]: filter.tenant
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.plans,
        as: 'plan',

        where: filter.plan
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.plan
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  name: {
                    [Op.or]: filter.plan
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.agences,
        as: 'agences',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.provider_customer_id) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'subscriptions',
            'provider_customer_id',
            filter.provider_customer_id,
          ),
        };
      }

      if (filter.provider_subscription_id) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'subscriptions',
            'provider_subscription_id',
            filter.provider_subscription_id,
          ),
        };
      }

      if (filter.current_period_startRange) {
        const [start, end] = filter.current_period_startRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            current_period_start: {
              ...where.current_period_start,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            current_period_start: {
              ...where.current_period_start,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.current_period_endRange) {
        const [start, end] = filter.current_period_endRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            current_period_end: {
              ...where.current_period_end,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            current_period_end: {
              ...where.current_period_end,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.status) {
        where = {
          ...where,
          status: filter.status,
        };
      }

      if (filter.payment_provider) {
        where = {
          ...where,
          payment_provider: filter.payment_provider,
        };
      }

      if (filter.agences) {
        const listItems = filter.agences.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          agencesId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.agencesId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.subscriptions.findAndCountAll(
        queryOptions,
      );

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('subscriptions', 'provider_customer_id', query),
        ],
      };
    }

    const records = await db.subscriptions.findAll({
      attributes: ['id', 'provider_customer_id'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['provider_customer_id', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.provider_customer_id,
    }));
  }
};
